Orxonox: TiXmlBase Class Reference

# TiXmlBase Class Reference

`#include <src/tinyxml/tinyxml.h>`

Inheritance diagram for TiXmlBase:

List of all members.

## Public Types

enum

{
TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY,
TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES,
TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT,
TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA,
TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT
}

## Public Member Functions

int | Column () const
| See Row().
const void * | GetUserData () const
| Get a pointer to arbitrary user data.
void * | GetUserData ()
| Get a pointer to arbitrary user data.
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)=0
virtual void | Print (FILE *cfile, int depth) const =0
int | Row () const
void | SetUserData (void *user)
| Set a pointer to arbitrary user data.
| TiXmlBase ()
virtual | ~TiXmlBase ()

## Static Public Member Functions

static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.
static void | SetCondenseWhiteSpace (bool condense)

## Static Public Attributes

static const int | utf8ByteTable [256]

## Static Protected Member Functions

static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static bool | IsWhiteSpace (int c)
static bool | IsWhiteSpace (char c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)

## Protected Attributes

TiXmlCursor | location
void * | userData
| Field containing a generic user pointer.

## Static Protected Attributes

static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Private Types

enum | { NUM_ENTITY = 5, MAX_ENTITY_LENGTH = 6 }

## Private Member Functions

void | operator= (const TiXmlBase &base)
| TiXmlBase (const TiXmlBase &)

## Static Private Attributes

static bool | condenseWhiteSpace = true
static Entity | entity [NUM_ENTITY]

## Friends

class | TiXmlDocument
class | TiXmlElement
class | TiXmlNode

## Classes

struct | Entity

## Detailed Description

TiXmlBase is a base class for every class in TinyXml. It does little except to establish that TinyXml classes can be printed and provide some utility functions.

In XML, the document and elements can contain other elements and other types of nodes.

    	A Document can contain:	Element	(container or leaf)
    							Comment (leaf)
    							Unknown (leaf)
    							Declaration( leaf )

    	An Element can contain:	Element (container or leaf)
    							Text	(leaf)
    							Attributes (not on tree)
    							Comment (leaf)
    							Unknown (leaf)

    	A Decleration contains: Attributes (not on tree)

## Member Enumeration Documentation

anonymous enum

Enumerator:

  TIXML_NO_ERROR |
  TIXML_ERROR |
  TIXML_ERROR_OPENING_FILE |
  TIXML_ERROR_OUT_OF_MEMORY |
  TIXML_ERROR_PARSING_ELEMENT |
  TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME |
  TIXML_ERROR_READING_ELEMENT_VALUE |
  TIXML_ERROR_READING_ATTRIBUTES |
  TIXML_ERROR_PARSING_EMPTY |
  TIXML_ERROR_READING_END_TAG |
  TIXML_ERROR_PARSING_UNKNOWN |
  TIXML_ERROR_PARSING_COMMENT |
  TIXML_ERROR_PARSING_DECLARATION |
  TIXML_ERROR_DOCUMENT_EMPTY |
  TIXML_ERROR_EMBEDDED_NULL |
  TIXML_ERROR_PARSING_CDATA |
  TIXML_ERROR_DOCUMENT_TOP_ONLY |
  TIXML_ERROR_STRING_COUNT |

anonymous enum`[private]`

Enumerator:

  NUM_ENTITY |
  MAX_ENTITY_LENGTH |

## Constructor & Destructor Documentation

TiXmlBase::TiXmlBase | ( |  | ) | `[inline]`

virtual TiXmlBase::~TiXmlBase | ( |  | ) | `[inline, virtual]`

TiXmlBase::TiXmlBase | ( | const TiXmlBase & |  | ) | `[private]`

## Member Function Documentation

int TiXmlBase::Column | ( |  | ) | const`[inline]`

See Row().

References TiXmlCursor::col, and location.

void TiXmlBase::ConvertUTF32ToUTF8 | ( | unsigned long | input,
|  | char * | output,
|  | int * | length |
| ) |  |  | `[static, protected]`

Referenced by GetEntity().

void TiXmlBase::EncodeString | ( | const TIXML_STRING & | str,
|  | TIXML_STRING * | out |
| ) |  |  | `[static]`

Expands entities in a string. Note this should not contian the tag's '<', '>', etc, or they will be transformed into entities!

References entity.

Referenced by TiXmlText::Print(), TiXmlAttribute::Print(), and TiXmlPrinter::Visit().

static const char* TiXmlBase::GetChar | ( | const char * | p,
|  | char * | _value,
|  | int * | length,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[inline, static, protected]`

References GetEntity(), TIXML_ENCODING_UTF8, and utf8ByteTable.

Referenced by ReadText().

const char * TiXmlBase::GetEntity | ( | const char * | in,
|  | char * | value,
|  | int * | length,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

References TiXmlBase::Entity::chr, ConvertUTF32ToUTF8(), entity, NUM_ENTITY, TIXML_ENCODING_UTF8, and TIXML_STRING.

Referenced by GetChar().

const void* TiXmlBase::GetUserData | ( |  | ) | const`[inline]`

Get a pointer to arbitrary user data.

References userData.

void* TiXmlBase::GetUserData | ( |  | ) | `[inline]`

Get a pointer to arbitrary user data.

References userData.

int TiXmlBase::IsAlpha | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

Referenced by TiXmlNode::Identify(), and ReadName().

int TiXmlBase::IsAlphaNum | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

Referenced by ReadName().

static bool TiXmlBase::IsWhiteSpace | ( | int | c | ) | `[inline, static, protected]`

References IsWhiteSpace().

static bool TiXmlBase::IsWhiteSpace | ( | char | c | ) | `[inline, static, protected]`

Referenced by TiXmlText::Blank(), IsWhiteSpace(), TiXmlStylesheetReference::Parse(), TiXmlDeclaration::Parse(), TiXmlAttribute::Parse(), ReadText(), and SkipWhiteSpace().

static bool TiXmlBase::IsWhiteSpaceCondensed | ( |  | ) | `[inline, static]`

Return the current white space setting.

References condenseWhiteSpace.

Referenced by TiXmlElement::ReadValue().

void TiXmlBase::operator= | ( | const TiXmlBase & | base | ) | `[private]`

virtual const char* TiXmlBase::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[pure virtual]`

Implemented in TiXmlAttribute, TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlStylesheetReference, TiXmlUnknown, and TiXmlDocument.

Referenced by TiXmlDocument::Parse(), and TiXmlElement::ReadValue().

virtual void TiXmlBase::Print | ( | FILE * | cfile,
|  | int | depth |
| ) |  |  | const`[pure virtual]`

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implemented in TiXmlAttribute, TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlStylesheetReference, TiXmlUnknown, and TiXmlDocument.

Referenced by TiXmlElement::Print().

const char * TiXmlBase::ReadName | ( | const char * | p,
|  | TIXML_STRING * | name,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

References IsAlpha(), and IsAlphaNum().

Referenced by TiXmlAttribute::Parse(), and TiXmlElement::Parse().

const char * TiXmlBase::ReadText | ( | const char * | in,
|  | TIXML_STRING * | text,
|  | bool | ignoreWhiteSpace,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

References condenseWhiteSpace, GetChar(), IsWhiteSpace(), SkipWhiteSpace(), and StringEqual().

Referenced by TiXmlText::Parse(), and TiXmlAttribute::Parse().

int TiXmlBase::Row | ( |  | ) | const`[inline]`

Return the position, in the original source file, of this node or attribute. The row and column are 1-based. (That is the first row and first column is 1,1). If the returns values are 0 or less, then the parser does not have a row and column value.

Generally, the row and column value will be set when the TiXmlDocument::Load(), TiXmlDocument::LoadFile(), or any TiXmlNode::Parse() is called. It will NOT be set when the DOM was created from operator>>.

The values reflect the initial load. Once the DOM is modified programmatically (by adding or changing nodes and attributes) the new values will NOT update to reflect changes in the document.

There is a minor performance cost to computing the row and column. Computation can be disabled if TiXmlDocument::SetTabSize() is called with 0 as the value.

See also:
  TiXmlDocument::SetTabSize()

References location, and TiXmlCursor::row.

static void TiXmlBase::SetCondenseWhiteSpace | ( | bool | condense | ) | `[inline, static]`

The world does not agree on whether white space should be kept or not. In order to make everyone happy, these global, static functions are provided to set whether or not TinyXml will condense all white space into a single space or not. The default is to condense. Note changing this value is not thread safe.

References condenseWhiteSpace.

void TiXmlBase::SetUserData | ( | void * | user | ) | `[inline]`

Set a pointer to arbitrary user data.

References userData.

const char * TiXmlBase::SkipWhiteSpace | ( | const char * | p,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

References IsWhiteSpace(), TIXML_ENCODING_UTF8, TIXML_UTF_LEAD_0, TIXML_UTF_LEAD_1, TIXML_UTF_LEAD_2, and orxonox::KeyCode::U.

Referenced by TiXmlNode::Identify(), TiXmlStylesheetReference::Parse(), TiXmlDeclaration::Parse(), TiXmlAttribute::Parse(), TiXmlComment::Parse(), TiXmlUnknown::Parse(), TiXmlElement::Parse(), TiXmlDocument::Parse(), ReadText(), and TiXmlElement::ReadValue().

bool TiXmlBase::StringEqual | ( | const char * | p,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[static, protected]`

References ToLower().

Referenced by TiXmlNode::Identify(), TiXmlStylesheetReference::Parse(), TiXmlDeclaration::Parse(), TiXmlText::Parse(), TiXmlComment::Parse(), TiXmlElement::Parse(), TiXmlDocument::Parse(), ReadText(), and TiXmlElement::ReadValue().

static int TiXmlBase::ToLower | ( | int | v,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[inline, static, protected]`

References TIXML_ENCODING_UTF8.

Referenced by StringEqual().

## Friends And Related Function Documentation

friend class TiXmlDocument`[friend]`

Reimplemented in TiXmlNode.

friend class TiXmlElement`[friend]`

Reimplemented in TiXmlNode, and TiXmlText.

friend class TiXmlNode`[friend]`

## Member Data Documentation

bool TiXmlBase::condenseWhiteSpace = true`[static, private]`

Referenced by IsWhiteSpaceCondensed(), ReadText(), and SetCondenseWhiteSpace().

TiXmlBase::Entity TiXmlBase::entity`[static, private]`

Initial value:

    {
        { "&amp;",  5, '&' },
        { "&lt;",   4, '<' },
        { "&gt;",   4, '>' },
        { "&quot;", 6, '\"' },
        { "&apos;", 6, '\'' }
    }

Referenced by EncodeString(), and GetEntity().

const char * TiXmlBase::errorString`[static, protected]`

Initial value:

    {
        "No error",
        "Error",
        "Failed to open file",
        "Memory allocation failed.",
        "Error parsing Element.",
        "Failed to read Element name",
        "Error reading Element value.",
        "Error reading Attributes.",
        "Error: empty tag.",
        "Error reading end tag.",
        "Error parsing Unknown.",
        "Error parsing Comment.",
        "Error parsing Declaration.",
        "Error document empty.",
        "Error null (0) or unexpected EOF found in input stream.",
        "Error parsing CDATA.",
        "Error when TiXmlDocument added to document, because TiXmlDocument can only be at the root.",
    }

Referenced by TiXmlDocument::SetError().

TiXmlCursor TiXmlBase::location`[protected]`

Referenced by Column(), TiXmlDocument::LoadFile(), TiXmlStylesheetReference::Parse(), TiXmlDeclaration::Parse(), TiXmlText::Parse(), TiXmlAttribute::Parse(), TiXmlComment::Parse(), TiXmlUnknown::Parse(), TiXmlElement::Parse(), TiXmlDocument::Parse(), and Row().

void* TiXmlBase::userData`[protected]`

Field containing a generic user pointer.

Referenced by TiXmlNode::CopyTo(), GetUserData(), and SetUserData().

const int TiXmlBase::utf8ByteTable`[static]`

Initial value:

    {

            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
            1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
            2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
            3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,
            4,  4,  4,  4,  4,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
    }

Referenced by GetChar(), and TiXmlParsingData::Stamp().

The documentation for this class was generated from the following files:

- src/tinyxml/tinyxml.h
- src/tinyxml/tinyxml.cpp
- src/tinyxml/tinyxmlerror.cpp
- src/tinyxml/tinyxmlparser.cpp